model tutorial_gis_city_traffic

global {
 int count<-0;
 int number<-0;
 int grid_width<-15 parameter:"grid width";
 int grid_height<-15 parameter:"grid height";
 reflex addcount{
  count<-count+1;
     }
 reflex add_overlapping1 when:count=5{
      create shop_home_overlapping number: 1;
      number<-number+1;
 }
 reflex add_overlapping2 when:count=5{
      create shop_home_overlapping number: 1;
      number<-number+1;
 }
 reflex add_overlapping3 when:count=5{
      create shop_home_overlapping number: 1;
      number<-number+1;
 }
 
 reflex add_neighbors when:count=10{
  create shop_home_nei number:3;
 }
 file blue_shops <- file('../includes/model/9.shp');
  file yellow_homes <- file('../includes/model/7.shp');
    file shape_file_roads <- file("../includes/model/14.shp");
   file shape_file_bounds <- file("../includes/model/16.shp");

    geometry shape <- envelope(shape_file_roads);
   
    float step <- 10 #mn;
     graph road_network;
     graph the_graphhome;
     graph the_graphshop;
     int changetime <- 2;
     int current_hour update: (time / #seconds) mod 60;
     int init_shop_number<-50;

   init {
        create shop from: blue_shops {
           
        }
        create bounds from:shape_file_bounds
        {
         
        }
       
        create home from: yellow_homes {
      
        }
       create road from: shape_file_roads{
        
       }
     
    }
    
 
}
species shop_home_overlapping{

 list<cell> going_to_change <- cell where (!empty(bounds overlapping each)); 
 list<cell> going_to_change_small <-copy_between(going_to_change, 0,3);
  point location1<-(going_to_change_small at number).location ;
    
    rgb color;
    
  init{
   
   location<-location1;
   color<-#blue;
     
  }
  
 reflex overlapping_move_yellow when:(count>=10)and(count<=20)
 {  
     color<-#yellow;

}
reflex overlapping_move_blue when:(count>=21)and(count<=29)
{
 color<-#blue;
}

 reflex die_overlapping when:(count=30) {
        do die ;
    }
 aspect base {
        draw cube(15) color: color;
    }
}

species shop_home_nei{
list<cell> going_to_change <- cell where (!empty(bounds overlapping each)); 
list<cell> going_to_change_small <-copy_between(going_to_change, 0,3);
list<cell> neighbours<-(one_of(going_to_change_small) neighbors_at 1);

 point location2;
 
 
 
 rgb color;
 
  init
  {
   
   loop i from: 0 to: 1000
   {
    location2 <- one_of(neighbours).location;
    location<-location2;
    if(empty(shop_home_overlapping at_distance 0))
    {
     break;
    }
   }
   
   color<-#blue;
  }

 reflex nei_move_yellow when:(count>=13)and(count<=17){  
     color<-#yellow;

}
 reflex nei_move_blue when:(count>=18)and(count<=24){  
     color<-#blue;

}
 reflex die_nei when:(count=25) {
        do die ;
    }
 aspect base {
        draw cube(15) color:color;
    }
}

species bounds{
 
 aspect geom{
  draw shape color:#black;
 }
}

species shop {
 
    float height <- 1#m;
    
  
    aspect geom {
        draw shape color: #blue depth: height;
    }
}

species home {
 
 
    float height <- 1#m;
    
    aspect geom {
        draw shape color: #yellow depth: height;
    }
}

species road {
    geometry display_shape <- shape + 2.0;
    aspect geom {
        draw display_shape color: #black depth: 3.0;
    }
}

grid cell cell_width:grid_width cell_height:grid_height neighbors: 4
{
}

experiment shopandhouse type: gui {
  // parameter "Shapefile for the buildings:" var: shape_file_buildings category: "GIS" ;
   parameter "Shapefile for the roads:" var: shape_file_roads category: "GIS" ;
   // parameter "Shapefile for the bounds:" var: shape_file_bounds category: "GIS" ;

    output {
        
        display map_3D type: opengl ambient_light: 120 {
            species road aspect:geom refresh:true;
            species home aspect:geom refresh:true;   
            species shop aspect:geom refresh:true; 
            grid cell lines:#black;
            species shop_home_overlapping aspect: base refresh:true ;
            species shop_home_nei aspect:base refresh:true;
            
   
                   
        }
        
    }
}