model modeling_informal_settlement

species male skills: [moving]
{
	home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #black ;
    
    string rule;
    
    list<cell> next_to_street;
  	
  	list<pink_cube> pink_collection;
  	
  	list<cell> mfc_collection;
 
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_male))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_male))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if (flip(night_male))
  		{
  			ask pink_collection
    		{
    			do die;
    		}
    		
  			rule <- 'night_rule';
  			end_point <- any_location_in(living_place);
  			move <- true;
  			
  			if (flip(night_male))
  			{
  				pink_collection <- [];
  				
  				ask next_to_street
  				{
  					if (self.color = # lightskyblue or self.color = # green)
  					{
  						create pink_cube returns: each_one
  						{
  							location <- myself.location;
  						}

  						myself.pink_collection <- myself.pink_collection union each_one;
  					}

  				}

  			}

  		}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_male))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(dinner_male))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(general_male))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
    	}
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 20)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}

    aspect base 
    {
        draw circle(5.5#m) color: color depth: 15#m;
    }
}

species female skills:[moving]
{
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #red ;
    
    string rule;
  
  	list<cell> next_to_street;
  	
  	list<pink_cube> pink_collection;
  	
  	list<cell> mfc_collection;
  	
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_female))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(night_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(dinner_female))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(general_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	
        	if (flip(general_female))
        	{ 	
 				pink_collection <- [];
 				
        		ask next_to_street
        		{
        			create pink_cube returns: each_one
        			{
        				location <- myself.location;
        			}
        			myself.pink_collection <- myself.pink_collection union each_one;
        		}
        	}
    	}
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 3)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}

    aspect base 
    {
        draw circle(4.5#m) color: color depth: 15#m;
    }
}

species kid skills: [moving]
{
  	rgb color <- #grey;
  
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    string rule;
    
    list<cell> next_to_street;
  	
  	list<pink_cube> pink_collection;
  	
  	list<cell> mfc_collection;
  
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_kid))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(night_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(dinner_kid))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 480 or count mod 1440 = 960 or count mod 1440 = 780
  	{
  		if (flip(general_kid))
  		{
  			ask pink_collection
    		{
    			do die;
    		}
    		
  			rule <- 'general_rule';
  			end_point <- any_location_in(living_place);
  			move <- true;
  			
  			if (flip(general_kid))
  			{
  				pink_collection <- [];
  				
  				ask next_to_street
  				{
  					if (self.color = # lightskyblue or self.color = # green)
  					{
  						create pink_cube returns: each_one
  						{
  							location <- myself.location;
  						}

  						myself.pink_collection <- myself.pink_collection union each_one;
  					}

  				}

  			}

  		}

  	}
  	
    
    reflex campus when: count mod 1440 = 420 or count mod 1440 = 720
    {
    	if(flip(school_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'school_rule';
    		school target_school <- one_of(school_collection);
        	end_point <- any_location_in(target_school);
        	move <- true;
    	}
    }
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}
	
	reflex school_wander when: rule = 'school_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}

    aspect base 
    {
        draw circle(3.5#m) color: color depth: 15#m;
    }
}

species visitor skills:[moving]
{
  	rgb color <- #purple ;
  	
  	home living_place ;
   
    point end_point; 
    
    bool move <- false;

  	string rule;
  	
  	int current_count <- -100000;
  	
  	list<cyan_cube> cyan_collection;
 
  	list<cell> red_collection;
  	
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_visitor))
    	{
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_visitor))
        	{
        		red_collection <- [];
        		cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_1
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.red_collection;
        			}
        		}
        		
        		ask one_of(red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.cyan_collection <- one_cyan_cube;
        			myself.current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(night_visitor))
    	{
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_visitor))
    	{
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	 	
        	if(flip(dinner_visitor))
        	{
        		red_collection <- [];
        		cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_1
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.red_collection;
        			}
        		}
        		
        		ask one_of(red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.cyan_collection <- one_cyan_cube;
        			myself.current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(general_visitor))
    	{
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	
        	if(flip(general_visitor))
        	{
        		red_collection <- [];
        		cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_3
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.red_collection;
        			}
        		}
        		
        		ask one_of(red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.cyan_collection <- one_cyan_cube;
        			myself.current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex kill_cyan_cube when: length(cyan_collection) != 0 and count = current_count + 30
  	{
  		ask cyan_collection
  		{
  			do die;
  		}
  		
  		current_count <- -10000;
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 20)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}

    aspect base 
    {
        draw circle(5.5#m) color: color depth: 15#m;
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

global 
{
	int count;
	int current_hour <- 0;
	int current_minute;
	string current_minute_string <- '00';
	int current_day <- 1;
 
	int total_homes;
 	float male_per_home <- 1.0 parameter: 'male per home';
 	float female_per_home <- 1.0 parameter: 'female per home';
	float kid_per_home <- 1.0 parameter: 'kid per home';
 	float visitor_per_home <- 0.3 parameter: 'visitor per home';
 	
 	float general_male <- 0.5 parameter: 'x% male affected by general rule';
 	float general_female <- 0.5 parameter: 'x% female affected by general rule';
 	float general_kid <- 0.3 parameter: 'x% kid affected by general rule';
 	float general_visitor <- 0.4 parameter: 'x% visitor affected by general rule';
 	float night_male <- 0.9 parameter: 'x% male affected by night rule';
 	float night_female <- 0.9 parameter: 'x% female affected by night rule';
 	float night_kid <- 0.95 parameter: 'x% kid affected by night rule';
 	float night_visitor <- 0.9 parameter: 'x% visitor affected by night rule';
 	float school_kid <- 0.3 parameter: 'x% kid affected by school rule';
 	float lunch_male <- 0.5 parameter: 'x% male affected by lunch rule';
 	float lunch_female <- 0.9 parameter: 'x% female affected by lunch rule';
 	float lunch_kid <- 0.5 parameter: 'x% kid affected by lunch rule';
 	float lunch_visitor <- 0.9 parameter: 'x% visitor affected by lunch rule';
 	float dinner_male <- 0.9 parameter: 'x% male affected by dinner rule';
 	float dinner_female <- 0.5 parameter: 'x% female affected by dinner rule';
 	float dinner_kid <- 0.3 parameter: 'x% kid affected by dinner rule';
 	float dinner_visitor <- 0.4 parameter: 'x% visitor affected by dinner rule';
 	
 	int total_male;
 	int total_female;
 	int total_kid;
 	int total_visitor;
 
	float moving_speed <- 230.0 * 30 # km / # h;
 
 	list<Square> square_collection;
 	list<home> home_collection;
 	list<street> street_collection;
 	list<school> school_collection;
 	list<shop> shop_collection;
 	
 	list<cell> total_street_cells;
 	list<cell> total_street_cells_near_shops_3;
 	list<cell> total_street_cells_near_shops_1;
 	
 	list<cell> mfc;
	
	file blue_shops <- file('../includes/model/shop.shp');
	file yellow_homes <- file('../includes/model/home.shp');
    
    file bound <- file("../includes/model/road.shp");
    
	file square_file <- file("../includes/model/square.shp");
	file school_file <- file("../includes/model/school.shp");
	file street_file <- file("../includes/model/street.shp");
 
 	geometry shape <- envelope(bound);

    init 
    {
    	count <- 0;
    	
    	create home from: yellow_homes 
    	{
      
     	}
     	home_collection <- list<home>(home);
     
        create shop from: blue_shops 
        {
           
        }
        shop_collection <- list<shop>(shop);
        
        create Square from: square_file
        {
         
        }
        square_collection <- list<Square>(Square);
        
        create school from: school_file
        {
        	
        }
        school_collection<-list<school>(school);
        
        create road from: bound
        {
       
        }
        
        create street from: street_file
        {
        
        }
        street_collection <- list<street>(street);
     
  		list<cell> total_home_cells <- list<cell>(agents_overlapping(home));
  		list<cell> total_shop_cells <- list<cell>(agents_overlapping(shop));
  		
  		ask total_home_cells
  		{
  			create home_cube
  			{
  				location <- myself.location;
  			}
  		}
  		
  		ask total_shop_cells
  		{
  			create shop_cube
  			{
  				location <- myself.location;
  			}
  		}
  		
  		total_street_cells <- list<cell>(agents_overlapping(street));
  		
  		ask total_street_cells
  		{
  			ask total_shop_cells
  			{
  				if(distance_to(self.location,myself.location) <= 3.5)
  				{
  					add myself to: total_street_cells_near_shops_3;
  				}
  			}
  		}
  		
  		ask total_street_cells
  		{
  			ask total_shop_cells
  			{
  				if(distance_to(self.location,myself.location) <= 1.5)
  				{
  					add myself to: total_street_cells_near_shops_1;
  				}
  			}
  		}
  
  		//12 units = 1 home
  		total_homes <- int((length(total_home_cells)) / 12);
  
  		total_male <- int(total_homes * male_per_home);
  		total_female <- int(total_homes * female_per_home);
  		total_kid <- int(total_homes * kid_per_home);
  		total_visitor <- int(total_homes * visitor_per_home);
  
        create female number: total_female 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create male number: total_male 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create kid number: total_kid 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create visitor number: total_visitor 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
        }
	}
	
	int total_people;
	
	reflex color_update
	{
		mfc <- [];
		
		ask total_street_cells
		{
			total_people <- 0;
			
			ask male
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask female
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask kid
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}
			
			if(total_people >= 5)
			{
				add self to: mfc;
			}

			ask visitor
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			if (total_people = 0)
			{
				color <- # lightskyblue;
			}

			if (total_people = 1)
			{
				color <- # green;
			}

			if (total_people = 2)
			{
				color <- # yellow;
			}

			if (total_people = 3)
			{
				color <- # orange;
			}

			if (total_people >= 4)
			{
				color <- # red;
			}

		}

	}
	
	reflex addcount
 	{
   		count <- count + 30;
   		current_hour <- int(count / 60) mod 24;
   		current_minute <- count mod 60;
   		
   		if(current_minute = 30)
   		{
   			current_minute_string <- '30';
   		}
   		else
   		{
   			current_minute_string <- '00';
   		}
   		
   		current_day <- int(count / 1440) + 1;
 	}
}


species bounds
{
	aspect geom
 	{
  		draw shape color: #black;
 	}
}

species shop 
{
 
    float height <- 1#m;
  
    aspect geom 
    {
        draw shape color: #blue depth: height;
    }
}

species home 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #yellow depth: height;
    }
}

species road 
{
    geometry display_shape <- shape + 2.0;
    aspect geom 
    {
        draw display_shape color: #black depth: 1.0;
    }
}
species street
{
 	float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #cyan depth: height;
    }
}

species Square 
{
    float height <- 20#m;
    
    aspect geom 
    {
        draw shape color: #lawngreen depth: height;
    }
}

species school 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #green depth: height;
    }
}

species pink_cube
{
	aspect geom 
    {
        draw cube(15) color: #pink;
    }
} 

species cyan_cube
{
	aspect geom 
    {
        draw cube(16) color: #cyan;
    }
} 

species shop_cube
{
	aspect geom 
    {
        draw cube(15) color: #blue;
    }
} 

species home_cube
{
	aspect geom 
    {
        draw cube(15) color: #yellow;
    }
} 

grid cell cell_width: 15 cell_height: 15 neighbors: 8
{
	rgb color;
}

experiment shopandhouse type: gui 
{
   parameter "Shapefile for the roads:" var: bound category: "GIS" ;
   
   output 
   {
        display map_3D type: opengl ambient_light: 120 synchronized: true
        {
        	grid cell;
        	
        	species road aspect: geom refresh:true;
            //species home aspect: geom refresh:true;   
            //species shop aspect: geom refresh:true; 
            species shop_cube aspect: geom refresh:true transparency: 0.9;
            species home_cube aspect: geom refresh:true transparency: 0.9; 
            species Square aspect: geom refresh:true; 
            species school aspect: geom refresh:true; 
            species pink_cube aspect: geom refresh:true; 
            species cyan_cube aspect: geom refresh:true; 
          
            species male aspect: base ;
            species kid aspect: base ;                                                
            species visitor aspect: base ;
            species female aspect: base ;
            
            graphics 'current time'
			{
				draw string(current_hour) + ':' + current_minute_string at: { 800, 800 } color: # black font: font("Helvetica", 45 , #plain);
				draw 'Day' + string(current_day) at: { 800, 400 } color: # black font: font("Helvetica", 35 , #plain);
			}
        }
        
        display pink_chart
        {
        	chart "number of pink_cube " type: series x_label: "Time" x_serie_labels: string(current_hour) + ':' + current_minute_string y_label: 'Number of pink_cube'
        	{
        		data "pink_cube" value: length(pink_cube);
        	}

        }

        display cyan_chart
        {
        	chart "number of cyan_cube" type: series x_label: "Time" x_serie_labels: string(current_hour) + ':' + current_minute_string y_label: 'Number of cyan_cube'
        	{
        		data "cyan_cube" value: length(cyan_cube) color: # blue;
        	}

        }

        display my_chart
        {
        	chart "number of cyan_cube and number of pink_cube" type: series x_label: "Time" x_serie_labels: string(current_hour) + ':' + current_minute_string y_label: 'Number of cube'
        	{
        		data "pink_cibe" value: length(pink_cube);
        		data "cyan_cube" value: length(cyan_cube);
        	}

        }
    }
}
