model tutorial_gis_city_traffic

global 
{
 int count <- 0;

 
 int total_homes;
 float male_per_home <- 1.0 parameter: 'male per home';
 float female_per_home <- 1.0 parameter: 'female per home';
 float kid_per_home <- 1.0 parameter: 'kid per home';
  float visitor_per_home <- 0.3 parameter: 'visitor per home';
 
  int total_male;
  int total_female;
  int total_kid;
  int total_visitor;
 
 float moving_speed <- 230.0 #km / #h;
 
 
  list<Square> square_collection;
  list<home> home_collection;
  list<street> street_collection;
  list<school>school_collection;
  list<cell> home_cell;
  

  
  list<cell> total_street_cells;
  
  
file blue_shops <- file('../includes/model/9.shp');
file yellow_homes <- file('../includes/model/7.shp');
file bound <- file("../includes/model/14.shp");
file square_file <- file("../includes/model/square.shp");
file school_file <- file("../includes/model/school.shp");
 file street_file <- file("../includes/model/street.shp");
 
 geometry shape <- envelope(bound);

    init 
    {
     create home from: yellow_homes 
     {
      
      }
      home_collection <- list<home>(home);
     
        create shop from: blue_shops 
        {
           
        }
        
        create Square from: square_file
        {
         
        }
        square_collection <- list<Square>(Square);
        
        create school from: school_file
        {
         
        }
        school_collection<-list<school>(school);
        
        create school from: school_file
        {
        
        }
        
        create road from: bound
        {
       
        }
        
        create street from: street_file
        {
        
        }
        street_collection <- list<street>(street);
     
    list<cell> total_home_cells <- list<cell>(agents_inside(home)) ;
    
    total_street_cells <- list<cell>(agents_inside(street)) union list<cell>(agents_overlapping(street));
    
  
    //12 units = 1 home
    total_homes <- int((length(total_home_cells)) / 12);
  
    total_male <- int(total_homes * male_per_home);
    total_female <- int(total_homes * female_per_home);
    total_kid <- int(total_homes * kid_per_home);
    total_visitor <- int(total_homes * visitor_per_home);
    
    list<female>female_home_bounds;
    

 
   
        create female number: total_female 
        {
            living_place <- one_of(home_collection) ;
            home_cell<-overlapping(cell,living_place);
            female_home_bounds<-list<female>(home_cell inter list<cell>(agents_overlapping(street)));
            location <- any_location_in (living_place);            
            speed <- moving_speed ;
            end_point <- location;
            
        }
        
        create male number: total_male 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
        }
        
        create kid number: total_kid 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
        }
        
        create visitor number: total_visitor 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
        }
 }
    
    reflex addcount
  {
     count <- count + 1;
  }
 
 int total_people;
 
 list<male> male_density ;
 list<female> female_density ;
 list<kid> kid_density ;
 list<visitor> visitor_density;
 
 reflex color_update 
 {
  loop i from: 0 to: length(total_street_cells) - 1
  {
   total_people <- 0;
   
   ask total_street_cells at i
   {
   		 	
                male_density <- male at_distance 1;
				female_density <- female at_distance 1;
				kid_density <- kid  at_distance 1;
				visitor_density <- visitor at_distance 1;
    total_people <- length(male_density) + length(female_density) + length(kid_density) + length(visitor_density);
    
    if(total_people = 0)
    {
     color <- #blue;
    }
    if(total_people = 1)
    {
     color <- #green;
    }
    if(total_people = 2)
    {
     color <- #yellow;
    }
    if(total_people = 3)
    {
     color <- #orange;
    }
    if(total_people >= 4)
    {
     color <- #red;
    }
   }
  }
 }
}



species bounds
{
 aspect geom
  {
    draw shape color: #black;
  }
}

species shop 
{
 
    float height <- 1#m;
  
    aspect geom 
    {
        draw shape color: #blue depth: height;
    }
}

species home 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #yellow depth: height;
    }
}

species road 
{
    geometry display_shape <- shape + 2.0;
    aspect geom 
    {
        draw display_shape color: #black depth: 1.0;
    }
}
species street
{
  float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #cyan depth: height;
    }
}

species Square 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #purple depth: height;
    }
}

species school 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #green depth: height;
    }
}

species male skills: [moving]
{
 home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #black ;
  
   reflex go_square when: count mod 1440 = 840 or count mod 1440 = 1080
   {
     
      Square target_square <- one_of(square_collection);
        end_point <- any_location_in(target_square);
        move <- true;
      
   }
   
   reflex go_home when: count mod 1440 = 1200
   {
     end_point <- any_location_in(living_place);
     move <- true;
   }
   
   reflex go_street when: count mod 1440 = 420 or count mod 1440 = 960
   {
      street target_street <- one_of(street_collection);
        end_point <- any_location_in(target_street);
        move <- true;
   }
    
   reflex moving when: move = true
    {
       do goto target: end_point; 
      if(location = end_point)
      {
        move <- false;
      } 
    }
    
       reflex night_rule when: (count mod 1440 > 0 and count mod 1440 < 420 and move = false) or (count mod 1440 > 1200 and count mod 1440 < 1440 and move = false)
    {
     if(flip(0.1))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 5)
     {
      move <- true;
     }
    }
    reflex lunch_rule when: (count mod 1440> 840  and count mod 1440 <960 and move =false)
    {
    	 if(flip(0.5))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 20)
     {
      move <- true;
     }
    }
    
reflex dinner_rule when: (count mod 1440> 1080 and count mod 1440 <1200 and move =false) 
    {
    	 if(flip(0.1))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 20)
     {
      move <- true;
     }
    }
 reflex general_rule when:(count mod 1400>420 and count mod 1440< 840 and move=false) or (count mod 1440> 960 and count mod 1440 <1080 and move =false)
 {
 	if(flip(0.5))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 50)
     {
      move <- true;
     }
 }

    aspect base 
    {
        draw circle(3.5#m) color: color;
    }
     
}

species female skills:[moving]
{
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #cyan ;
  
   reflex go_square when: count mod 1440 = 840 or count mod 1440 = 1080
   {
     
      Square target_square <- one_of(square_collection);
        end_point <- any_location_in(target_square);
        move <- true;
      
   }
   
   reflex go_home when: count mod 1440 = 1200
   {
     end_point <- any_location_in(living_place);
        move <- true;
   }
   
   reflex go_street when: count mod 1440 = 420 or count mod 1440 = 960
   {
      street target_street <- one_of(street_collection);
        end_point <- any_location_in(target_street);
        move <- true;
   }
    
   reflex moving when: move = true
    { 
       do goto target: end_point; 
      if(location = end_point)
      {
        move <- false;
      }
    }
    
    reflex night_rule when: (count mod 1440 > 0 and count mod 1440 < 420 and move = false) or (count mod 1440 > 1200 and count mod 1440 < 1440 and move = false)
    {
     if(flip(0.1))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 5)
     {
      move <- true;
     }
    }
    reflex lunch_rule when: (count mod 1440> 840 and count mod 1440 <960 and move =false)
    {
    	 if(flip(0.1))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 10)
     {
      move <- true;
     }
    }
    
reflex dinner_rule when: (count mod 1440> 1080 and count mod 1440 <1200 and move =false) 
    {
    	 if(flip(0.5))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 10)
     {
      move <- true;
     }
    }
 reflex general_rule when:(count mod 1400>420 and count mod 1440<840 and move =false) or (count mod 1440> 960 and count mod 1440 <1080 and move =false)
 {
 	if(flip(0.5))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 8)
     {
      move <- true;
     }
 }
   
    aspect base 
    {
        draw circle(3.5#m) color: color;
    }
}

species kid skills: [moving]
{
   rgb color <- #grey;
  
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
  
   reflex go_square when: count mod 1440 = 840 or count mod 1440 = 1080
   {
      Square target_square <- one_of(square_collection);
        end_point <- any_location_in(target_square);
        move <- true;
   }
   
   reflex go_home when: count mod 1440 = 1200
   {
     end_point <- any_location_in(living_place);
        move <- true;
   }
   
   reflex go_school when: count mod 1440 = 420 or count mod 1440 = 720
   {
      school target_school <- one_of(school_collection);
        end_point <- any_location_in(target_school);
        move <- true;
   }
   
    reflex go_street when: count mod 1440 = 480 or count mod 1440 = 780 or count mod 1440=960
   {
      street target_street <- one_of(street_collection);
        end_point <- any_location_in(target_street);
        move <- true;
   }
  
   reflex moving when: move = true
    {
       do goto target: end_point; 
      if(location = end_point)
      {
        move <- false;
      }
    }

       reflex night_rule when: (count mod 1440 > 0 and count mod 1440 < 420 and move = false) or (count mod 1440 > 1200 and count mod 1440 < 1440 and move = false)
    {
     if(flip(0.05))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 5)
     {
      move <- true;
     }
    }
    reflex school_rule when:(count mod 1440>420 and count mod 1400 < 480 and move=false) or (count mod 1440>720 and count mod 1400 < 780 and move=false)
    
    {
    	if(flip(0.7))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 20)
     {
      move <- true;
     }
    }
    reflex lunch_rule when: (count mod 1440> 840 and count mod 1440 <960 and move =false)
    {
    	 if(flip(0.5))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 20)
     {
      move <- true;
     }
    }
    
reflex dinner_rule when: (count mod 1440> 1080 and count mod 1440 <1200 and move =false) 
    {
    	 if(flip(0.7))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 20)
     {
      move <- true;
     }
    }
 reflex general_rule when:(count mod 1400>480 and count mod 1440< 720 and move =false ) or (count mod 1440> 780 and count mod 1440 <840 and move =false)
 {
 	if(flip(0.7))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 20)
     {
      move <- true;
     }
 }

    aspect base 
    {
        draw circle(3.5#m) color: color;
    }
}

species visitor skills:[moving]
{
   rgb color <- #purple ;
   
   home living_place ;
   
    point end_point; 
    
    bool move <- false;

  
   reflex go_square when: count mod 1440 = 840 or count mod 1440 = 1080
   {
      Square target_square <- one_of(square_collection);
        end_point <- any_location_in(target_square);
        move <- true;
   }
   
   reflex go_home when: count mod 1440 = 1200
   {
     end_point <- any_location_in(living_place);
        move <- true;
   }
    
   reflex go_street when: count mod 1440 = 420 or count mod 1440 = 960
   {
     street target_street <- one_of(street_collection);
        end_point <- any_location_in(target_street);
        move <- true;
   }
    
   reflex moving when: move = true
    {
       do goto target: end_point; 
      if(location = end_point)
      {
        move <- false;
      }
    }
     reflex night_rule when: (count mod 1440 > 0 and count mod 1440 < 420 and move = false) or (count mod 1440 > 1200 and count mod 1440 < 1440 and move = false)
    {
     if(flip(0.1))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 5)
     {
      move <- true;
     }
    }
    reflex lunch_rule when: (count mod 1440> 840 and count mod 1440 <960 and move =false)
    {
    	 if(flip(0.1))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 10)
     {
      move <- true;
     }
    }
    
reflex dinner_rule when: (count mod 1440> 1080 and count mod 1440 <1200 and move =false) 
    {
    	 if(flip(0.6))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 10)
     {
      move <- true;
     }
    }
 reflex general_rule when:(count mod 1400>420 and count mod 1440<840 and move=false) or (count mod 1440> 960 and count mod 1440 <1080 and move =false)
 {
 	if(flip(0.6))
     {
      do wander;
     }
     if(distance_to(end_point,location) > 50)
     {
      move <- true;
     }
 }

    aspect base 
    {
        draw circle(3.5#m) color: color;
    }
}

grid cell cell_width:15 cell_height:15 neighbors: 4
{
 rgb color;
}

experiment shopandhouse type: gui 
{
   parameter "Shapefile for the roads:" var: bound category: "GIS" ;
   
   output 
   {
        display map_3D type: opengl ambient_light: 120 
        {
            species road aspect: geom refresh:true transparency: 0.8;
            species home aspect: geom refresh:true;   
            species shop aspect: geom refresh:true; 
            species Square aspect: geom refresh:true; 
            species school aspect: geom refresh:true; 
            grid cell lines: #black;
            species female aspect: base ;
            species male aspect: base ;
            species kid aspect: base ;                                                
            species visitor aspect: base ;
        }
    }
}