model tutorial_gis_city_traffic

species male skills: [moving]
{
	home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #black ;
    
    string rule;
    
    list<cell> next_to_street;
  	
  	list<pink_cube> night_pink_collection;
 
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(0.5))
    	{
    		ask night_pink_collection
    		{
    			do die;
    		}
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(0.9))
    	{
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    		if (flip(0.9) )
    		{
    			night_pink_collection <- [];
    			ask next_to_street
    			{ 
    			
        			if(self.color = #red or self.color=#green)
        		  {
    				create pink_cube returns: each_one
        			{
        				location <- myself.location;
        			}
        			myself.night_pink_collection <- myself.night_pink_collection union each_one;
        		  }
    		    }
    			
    			
    		}
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(0.9))
    	{
    		ask night_pink_collection
    		{
    			do die;
    		}
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(0.5))
    	{
    		ask night_pink_collection
    		{
    			do die;
    		}
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
    	}
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 20)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}

    aspect base 
    {
        draw circle(5.5#m) color: color depth: 2#m;
    }
}

species female skills:[moving]
{
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #red ;
    
    string rule;
  
  	list<cell> next_to_street;
  	
  	list<pink_cube> general_pink_collection;
  	
//  	reflex test when: count = 300
//  	{
//  		ask next_to_street
//  		{
//  			create pink_cube returns: each_one
//  			{
//  				location <- myself.location;
//  			}
//  			myself.collection <- myself.collection union each_one;
//  		}
//  	}
//  	
//  	reflex test1 when: count = 600
//  	{
//  		ask collection
//  		{
//  			do die;
//  		}
//  	}
//  	
//  	reflex test2 when: count = 450
//  	{
//  		ask next_to_street
//  		{
//  			create cyan_cube
//  			{
//  				location <- myself.location;
//  			}
//  		}
//  	}
  	
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(0.9))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(0.9))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(0.5))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(0.5))
    	{
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	
        	if (flip(0.5))
        	{ 	
 				general_pink_collection <- [];
 				
        		ask next_to_street
        		{
        			create pink_cube returns: each_one
        			{
        				location <- myself.location;
        			}
        			myself.general_pink_collection <- myself.general_pink_collection union each_one;
        		}
        	}
    	}
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 3)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}

    aspect base 
    {
        draw circle(4.5#m) color: color depth: 2#m;
    }
}

species kid skills: [moving]
{
  	rgb color <- #grey;
  
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    string rule;
    
     list<cell> next_to_street;
  	
  	list<pink_cube> general_pink_collection;
  
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(0.5))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(0.95))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(0.3))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex general when: count mod 1440 = 480 or count mod 1440 = 960 or count mod 1440 = 780
  	{
     	if(flip(0.3))
    	{
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	if (flip(0.3))
        	{ 	
              
 				general_pink_collection <- [];
 				
        		ask next_to_street
        		
        		{ 
        			if (self.color = #red or self.color=#green)
        		 {
        			create pink_cube returns: each_one
        			{
        				location <- myself.location;
        			}
        			myself.general_pink_collection <- myself.general_pink_collection union each_one;
        		  }
        	    }
        	}
      }
    	}
  	
    
    reflex campus when: count mod 1440 = 420 or count mod 1440 = 720
    {
    	if(flip(0.3))
    	{
    		ask general_pink_collection
    		{
    			do die;
    		}
    		rule <- 'school_rule';
    		school target_school <- one_of(school_collection);
        	end_point <- any_location_in(target_school);
        	move <- true;
    	}
    }
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}
	
	reflex school_wander when: rule = 'school_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 10)
     	{
     		move <- true;
     	}
	}

    aspect base 
    {
        draw circle(3.5#m) color: color depth: 2#m;
    }
}

species visitor skills:[moving]
{
  	rgb color <- #purple ;
  	
  	home living_place ;
   
    point end_point; 
    
    bool move <- false;

  	string rule;
  	
  	int general_current_count <- -100000;
  	int dinner_current_count<--100000;
  	
  	list<cyan_cube> general_cyan_collection;
  	list<cyan_cube> dinner_cyan_collection;
 
  	list<cell> general_red_collection;
  	list<cell>dinner_red_collection;
  	
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(0.9))
    	{
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(0.9))
    	{
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(0.4))
    	{
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	 	
        	if(flip(0.4))
        	{
        		
        		dinner_red_collection <- [];
        		dinner_cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_1
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.dinner_red_collection;
        			}
        		}
        		
        		ask one_of(dinner_red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.dinner_cyan_collection <- one_cyan_cube;
        			myself.dinner_current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(0.4))
    	{
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	
        	if(flip(0.4))
        	{
        		
        		general_red_collection <- [];
        		general_cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_3
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.general_red_collection;
        			}
        		}
        		
        		ask one_of(general_red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.general_cyan_collection <- one_cyan_cube;
        			myself.general_current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex kill_general_cyan_cube when: length(general_cyan_collection) != 0 and count = general_current_count + 30
  	{
  		ask general_cyan_collection
  		{
  			do die;
  		}
  		general_cyan_collection <- [];
  		general_current_count <- -10000;
  	}
  	
  		reflex kill_dinner_cyan_cube when: length(dinner_cyan_collection) != 0 and count = dinner_current_count + 30
  	{
  		ask dinner_cyan_collection
  		{
  			do die;
  		}
  		dinner_cyan_collection <- [];
  		dinner_current_count <- -10000;
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 20)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 10.0;
		if(distance_to(end_point,location) > 5)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 10.0 bounds: living_place;
	}

    aspect base 
    {
        draw circle(5.5#m) color: color depth: 2#m;
    }
}



























global 
{
	int count;
 
	int total_homes;
 	float male_per_home <- 0.1 parameter: 'male per home';
 	float female_per_home <- 0.1 parameter: 'female per home';
	float kid_per_home <- 0.1 parameter: 'kid per home';
 	float visitor_per_home <- 1.0 parameter: 'visitor per home';
 
 	int total_male;
 	int total_female;
 	int total_kid;
 	int total_visitor;
 
	float moving_speed <- 230.0*30 #km / #h;
 
 	list<Square> square_collection;
 	list<home> home_collection;
 	list<street> street_collection;
 	list<school> school_collection;
 	list<shop> shop_collection;
 	
 	list<cell> total_street_cells;
 	list<cell> total_street_cells_near_shops_3;
 	list<cell> total_street_cells_near_shops_1;
	
	file blue_shops <- file('../includes/model/shop.shp');
	file yellow_homes <- file('../includes/model/home.shp');
    
    file bound <- file("../includes/model/road.shp");
    
	file square_file <- file("../includes/model/square.shp");
	file school_file <- file("../includes/model/school.shp");
	file street_file <- file("../includes/model/street.shp");
 
 	geometry shape <- envelope(bound);

    init 
    {
    	count <- 0;
    	
    	create home from: yellow_homes 
    	{
      
     	}
     	home_collection <- list<home>(home);
     
        create shop from: blue_shops 
        {
           
        }
        shop_collection <- list<shop>(shop);
        
        create Square from: square_file
        {
         
        }
        square_collection <- list<Square>(Square);
        
        create school from: school_file
        {
        	
        }
        school_collection<-list<school>(school);
        
        create road from: bound
        {
       
        }
        
        create street from: street_file
        {
        
        }
        street_collection <- list<street>(street);
     
  		list<cell> total_home_cells <- list<cell>(agents_inside(home));
  		list<cell> total_shop_cells <- list<cell>(agents_overlapping(shop));
  		
  		total_street_cells <- list<cell>(agents_overlapping(street));
  		
  		ask total_street_cells
  		{
  			ask total_shop_cells
  			{
  				if(distance_to(self.location,myself.location) <= 3.5)
  				{
  					add myself to: total_street_cells_near_shops_3;
  				}
  			}
  		}
  		ask total_street_cells
  		{
  			ask total_shop_cells
  			{
  				if(distance_to(self.location,myself.location) <= 1.5)
  				{
  					add myself to: total_street_cells_near_shops_1;
  				}
  			}
  		}
  
  		//12 units = 1 home
  		total_homes <- int((length(total_home_cells)) / 12);
  
  		total_male <- int(total_homes * male_per_home);
  		total_female <- int(total_homes * female_per_home);
  		total_kid <- int(total_homes * kid_per_home);
  		total_visitor <- int(total_homes * visitor_per_home);
  
        create female number: total_female 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create male number: total_male 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create kid number: total_kid 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create visitor number: total_visitor 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
        }
	}
	
	int total_people;
	
	reflex color_update
	{
		ask total_street_cells
		{
			total_people <- 0;
			
			ask male
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask female
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask kid
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask visitor
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			if (total_people = 0)
			{
				color <- # lightskyblue;
			}

			if (total_people = 1)
			{
				color <- # green;
			}

			if (total_people = 2)
			{
				color <- # yellow;
			}

			if (total_people = 3)
			{
				color <- # orange;
			}

			if (total_people >= 4)
			{
				color <- # red;
			}

		}

	}
	
	reflex addcount
 	{
   		count <- count + 30;
 	}
}


species bounds
{
	aspect geom
 	{
  		draw shape color: #black;
 	}
}

species shop 
{
 
    float height <- 1#m;
  
    aspect geom 
    {
        draw shape color: #blue depth: height;
    }
}

species home 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #yellow depth: height;
    }
}

species road 
{
    geometry display_shape <- shape + 2.0;
    aspect geom 
    {
        draw display_shape color: #black depth: 1.0;
    }
}
species street
{
 	float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #cyan depth: height;
    }
}

species Square 
{
    float height <- 20#m;
    
    aspect geom 
    {
        draw shape color: #lawngreen depth: height;
    }
}

species school 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #green depth: height;
    }
}

species pink_cube
{
	aspect geom 
    {
        draw cube(15) color: #pink;
    }
} 

species cyan_cube
{
	aspect geom 
    {
        draw cube(20) color: #cyan;
    }
} 

grid cell cell_width: 15 cell_height: 15 neighbors: 8
{
	rgb color;
}

experiment shopandhouse type: gui 
{
   parameter "Shapefile for the roads:" var: bound category: "GIS" ;
   
   output 
   {
        display map_3D type: opengl ambient_light: 120 synchronized: true
        {
        	grid cell;
        	
        	species road aspect: geom refresh:true transparency: 0.8;
            species home aspect: geom refresh:true;   
            species shop aspect: geom refresh:true; 
            species Square aspect: geom refresh:true; 
            species school aspect: geom refresh:true; 
            species pink_cube aspect: geom refresh:true; 
            species cyan_cube aspect: geom refresh:true; 
          
            species male aspect: base ;
            species kid aspect: base ;                                                
            species visitor aspect: base ;
            species female aspect: base ;
        }
    }
}