model modeling_informal_settlement

species male skills: [moving]
{
	home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #black ;
    
    string rule;
    
    list<cell> next_to_street;
  	
  	list<pink_cube> pink_collection;
  	
  	list<cell> mfc_collection;
 
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_male))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_male))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if (flip(night_male))
  		{
  			ask pink_collection
    		{
    			do die;
    		}
    		
  			rule <- 'night_rule';
  			end_point <- any_location_in(living_place);
  			move <- true;
  			
  			if (flip(night_male))
  			{
  				pink_collection <- [];
  				
  				ask next_to_street
  				{
  					if (self.color = # lightskyblue or self.color = # green)
  					{
  						create pink_cube returns: each_one
  						{
  							location <- myself.location;
  						}

  						myself.pink_collection <- myself.pink_collection union each_one;
  					}

  				}

  			}

  		}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_male))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(dinner_male))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(general_male))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
    	}
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0*15;
		if(distance_to(end_point,location) > 20*15)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 5.0*15;
		if(distance_to(end_point,location) > 10*15)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 5.0*15;
		if(distance_to(end_point,location) > 10*15)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 1.0*15 bounds: living_place;
	}

    aspect base 
    {
        draw circle(5.5#m) color: color depth: 2#m;
    }
}

species female skills:[moving]
{
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    rgb color <- #red ;
    
    string rule;
  
  	list<cell> next_to_street;
  	
  	list<pink_cube> pink_collection;
  	
  	list<cell> mfc_collection;
  	
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_female))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(night_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(dinner_female))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(general_female))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	
        	if (flip(general_female))
        	{ 	
 				pink_collection <- [];
 				
        		ask next_to_street
        		{
        			create pink_cube returns: each_one
        			{
        				location <- myself.location;
        			}
        			myself.pink_collection <- myself.pink_collection union each_one;
        		}
        	}
    	}
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 1.0*15;
		if(distance_to(end_point,location) > 3*15)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 2.0*15;
		if(distance_to(end_point,location) > 5*15)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 2.0*15;
		if(distance_to(end_point,location) > 5*15)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 1.0*15 bounds: living_place;
	}

    aspect base 
    {
        draw circle(4.5#m) color: color depth: 2#m;
    }
}

species kid skills: [moving]
{
  	rgb color <- #grey;
  
    home living_place ;
   
    point end_point; 
    
    bool move <- false;
    
    string rule;
    
    list<cell> next_to_street;
  	
  	list<pink_cube> pink_collection;
  	
  	list<cell> mfc_collection;
  
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_kid))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(night_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(dinner_kid))
        	{
        		pink_collection <- [];
        		mfc_collection <- [];
        		
        		ask mfc
        		{
        			bool temp <- true;
        			
        			ask cyan_cube
        			{
        				if(distance_to(self.location,myself.location) <= 2)
        				{
        					temp <- false;
        				}
        			}
        			
        			if(temp = true)
        			{
        				add self to: myself.mfc_collection;
        			}
        		}
        		
        		ask one_of(mfc_collection)
        		{
        			create pink_cube returns: one_pink_cube
        			{
        				location <- myself.location;
        			}
        			
        			myself.pink_collection <- myself.pink_collection union one_pink_cube;
        		}        		
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 480 or count mod 1440 = 960 or count mod 1440 = 780
  	{
  		if (flip(general_kid))
  		{
  			ask pink_collection
    		{
    			do die;
    		}
    		
  			rule <- 'general_rule';
  			end_point <- any_location_in(living_place);
  			move <- true;
  			
  			if (flip(general_kid))
  			{
  				pink_collection <- [];
  				
  				ask next_to_street
  				{
  					if (self.color = # lightskyblue or self.color = # green)
  					{
  						create pink_cube returns: each_one
  						{
  							location <- myself.location;
  						}

  						myself.pink_collection <- myself.pink_collection union each_one;
  					}

  				}

  			}

  		}

  	}
  	
    
    reflex campus when: count mod 1440 = 420 or count mod 1440 = 720
    {
    	if(flip(school_kid))
    	{
    		ask pink_collection
    		{
    			do die;
    		}
    		
    		rule <- 'school_rule';
    		school target_school <- one_of(school_collection);
        	end_point <- any_location_in(target_school);
        	move <- true;
    	}
    }
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 5.0*15;
		if(distance_to(end_point,location) > 10*15)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 5.0*15;
		if(distance_to(end_point,location) > 10*15)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 5.0*15;
		if(distance_to(end_point,location) > 10*15)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 1.0*15 bounds: living_place;
	}
	
	reflex school_wander when: rule = 'school_rule' and move = false
	{
		do wander speed: 5.0*15;
		if(distance_to(end_point,location) > 10*15)
     	{
     		move <- true;
     	}
	}

    aspect base 
    {
        draw circle(3.5#m) color: color depth: 2#m;
    }
}

species visitor skills:[moving]
{
  	rgb color <- #purple ;
  	
  	home living_place ;
   
    point end_point; 
    
    bool move <- false;

  	string rule;
  	
  	int current_count <- -100000;
  	
  	list<cyan_cube> cyan_collection;
 
  	list<cell> red_collection;
  	
  	reflex lunch when: count mod 1440 = 840
  	{
    	if(flip(lunch_visitor))
    	{
    		rule <- 'lunch_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	
        	if(flip(lunch_visitor))
        	{
        		red_collection <- [];
        		cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_1
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.red_collection;
        			}
        		}
        		
        		ask one_of(red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.cyan_collection <- one_cyan_cube;
        			myself.current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex night when: count mod 1440 = 1200
  	{
  		if(flip(night_visitor))
    	{
    		rule <- 'night_rule';
    		end_point <- any_location_in(living_place);
    		move <- true;
    	}
  	}
  	
  	reflex dinner when: count mod 1440 = 1080
  	{
     	if(flip(dinner_visitor))
    	{
    		rule <- 'dinner_rule';
    		Square target_square <- one_of(square_collection);
        	end_point <- any_location_in(target_square);
        	move <- true;
        	 	
        	if(flip(dinner_visitor))
        	{
        		red_collection <- [];
        		cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_1
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.red_collection;
        			}
        		}
        		
        		ask one_of(red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.cyan_collection <- one_cyan_cube;
        			myself.current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex general when: count mod 1440 = 420 or count mod 1440 = 960
  	{
     	if(flip(general_visitor))
    	{
    		rule <- 'general_rule';
    		end_point <- any_location_in(living_place);
        	move <- true;
        	
        	if(flip(general_visitor))
        	{
        		red_collection <- [];
        		cyan_collection <- [];
        		
        		ask total_street_cells_near_shops_3
        		{
        			if(self.color = #red)
        			{
        				add self to: myself.red_collection;
        			}
        		}
        		
        		ask one_of(red_collection)
        		{
        			create cyan_cube returns: one_cyan_cube
        			{
        				location <- myself.location;
        			}
        			myself.cyan_collection <- one_cyan_cube;
        			myself.current_count <- count;
        		}
        	}
    	}
  	}
  	
  	reflex kill_cyan_cube when: length(cyan_collection) != 0 and count = current_count + 30
  	{
  		ask cyan_collection
  		{
  			do die;
  		}
  		
  		current_count <- -10000;
  	}
    
  	reflex moving when: move = true
    {
      	do goto target: end_point; 
     	if(location = end_point)
     	{
      		move <- false;
     	} 
    }

	reflex general_wander when: rule = 'general_rule' and move = false
	{
		do wander speed: 10.0*15;
		if(distance_to(end_point,location) > 20*15)
     	{
     		move <- true;
     	}
	}
	
	reflex lunch_wander when: rule = 'lunch_rule' and move = false
	{
		do wander speed: 2.0*15;
		if(distance_to(end_point,location) > 5*15)
     	{
     		move <- true;
     	}
	}
	
	reflex dinner_wander when: rule = 'dinner_rule' and move = false
	{
		do wander speed: 2.0*15;
		if(distance_to(end_point,location) > 5*15)
     	{
     		move <- true;
     	}
	}
	
	reflex night_wander when: rule = 'night_rule' and move = false
	{
		do wander speed: 1.0*15 bounds: living_place;
	}

    aspect base 
    {
        draw circle(5.5#m) color: color depth: 2#m;
    }
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

global 
{
	int count;
	int current_hour <- 0;
	int current_minute;
	string current_minute_string <- '00';
	int current_day <- 1;
 
	int total_homes;
 	float male_per_home <- 1.0 parameter: 'male per home';
 	float female_per_home <- 1.0 parameter: 'female per home';
	float kid_per_home <- 1.0 parameter: 'kid per home';
 	float visitor_per_home <- 0.3 parameter: 'visitor per home';
 	
 	float general_male <- 0.5 parameter: 'x% male affected by general rule';
 	float general_female <- 0.5 parameter: 'x% female affected by general rule';
 	float general_kid <- 0.3 parameter: 'x% kid affected by general rule';
 	float general_visitor <- 0.4 parameter: 'x% visitor affected by general rule';
 	float night_male <- 0.9 parameter: 'x% male affected by night rule';
 	float night_female <- 0.9 parameter: 'x% female affected by night rule';
 	float night_kid <- 0.95 parameter: 'x% kid affected by night rule';
 	float night_visitor <- 0.9 parameter: 'x% visitor affected by night rule';
 	float school_kid <- 0.3 parameter: 'x% kid affected by school rule';
 	float lunch_male <- 0.5 parameter: 'x% male affected by lunch rule';
 	float lunch_female <- 0.9 parameter: 'x% female affected by lunch rule';
 	float lunch_kid <- 0.5 parameter: 'x% kid affected by lunch rule';
 	float lunch_visitor <- 0.9 parameter: 'x% visitor affected by lunch rule';
 	float dinner_male <- 0.9 parameter: 'x% male affected by dinner rule';
 	float dinner_female <- 0.5 parameter: 'x% female affected by dinner rule';
 	float dinner_kid <- 0.3 parameter: 'x% kid affected by dinner rule';
 	float dinner_visitor <- 0.4 parameter: 'x% visitor affected by dinner rule';
 	
 	int total_male;
 	int total_female;
 	int total_kid;
 	int total_visitor;
 
	float moving_speed <- 230.0 * 30 # km / # h;
 
 	list<Square> square_collection;
 	list<home> home_collection;
 	list<street> street_collection;
 	list<school> school_collection;
 	list<shop> shop_collection;
 	list<mainroad>mainroad_collection;
 	
 	
 	list<cell> total_street_cells;
 	
 	list<cell> total_home_cells;
 	list<cell> total_shop_cells;
 	list<cell> total_mainroad_cells;
 	
 	list<cell> total_street_cells_near_shops_3;
 	list<cell> total_street_cells_near_shops_1;
 	
 	list<cell> total_street_cell_near_home_5;
 	list<cell> total_street_cell_near_home_2;
 	list<cell> total_home_cell_near_mainroad_30;
 	list<cell> total_home_cell_near_shop_3;
 	list<cell>total_home_cell_near_street_1;
 	list<cell>total_shop_cell_near_home_5;
 	list<cell>total_shop_cell_near_home_1;
 	list<cell>total_shop_cell_near_mainroad_3;
 
 	
 	list<cell> mfc;
 	
	list<pink_cube> pink_cube_general;
	list<cyan_cube> cyan_cube_general;
	list<blue_cube> blue_cube_general;
	list<yellow_cube>yellow_cube_general;
	
	int length_pink_cube_general;
	int length_cyan_cube_general;
	
	
	file blue_shops <- file('../includes/model/shop.shp');
	file yellow_homes <- file('../includes/model/home.shp');
    
    file bound <- file("../includes/model/road.shp");
    
    map home_map;
    map shop_map;
    
  
	
    
	file square_file <- file("../includes/model/square.shp");
	file school_file <- file("../includes/model/school.shp");
	file street_file <- file("../includes/model/street.shp");
	file main_road<-file("../includes/model/mainroad.shp");
 
 	geometry shape <- envelope(bound);

    init 
    {
    	count <- 0;
    	
    	create home from: yellow_homes 
    	{
      
     	}
     	home_collection <- list<home>(home);
     
        create shop from: blue_shops 
        {
           
        }
        shop_collection <- list<shop>(shop);
        
        create Square from: square_file
        {
         
        }
        square_collection <- list<Square>(Square);
        
        create school from: school_file
        {
        	
        }
        school_collection<-list<school>(school);
        
        create mainroad from: main_road
        {
        	
        }
        mainroad_collection<-list<mainroad>(mainroad);
        create road from: bound
        {
       
        }
        
        create street from: street_file
        {
        
        }
        
        street_collection <- list<street>(street);
     
  		 total_home_cells <- list<cell>(agents_inside(home));
  		 total_shop_cells <- list<cell>(agents_overlapping(shop));
  		
  		total_street_cells <- list<cell>(agents_overlapping(street));
  		total_mainroad_cells<-list<cell>(agents_overlapping(mainroad));
  		ask total_street_cells
  		{
  			ask total_shop_cells
  			{
  				if(distance_to(self.location,myself.location) <= 3.5)
  				{
  					add myself to: total_street_cells_near_shops_3;
  				}
  				
  				
  			}
  		}
  		
  		
        ask total_street_cells
        {
        	   ask total_home_cells
        	   {
        	   	if (distance_to(self.location,myself.location) <= 5)
        	   	{
        	   		add myself to: total_street_cell_near_home_5;
        	   	}
        	   	if (distance_to(self.location,myself.location) <= 2)
        	   	{
        	   		add myself to: total_street_cell_near_home_2;
        	   	} 
        	   }
        }
        ask total_home_cells
        {
        	   ask total_mainroad_cells
        	   {
        	   	if (distance_to(self.location,myself.location) <= 35)
        	   	{
        	   		add myself to: total_home_cell_near_mainroad_30;
        	   		
        	   	}
        	   }
        }
        ask total_home_cells
        {
        	ask total_shop_cells
        	{
        		if (distance_to(self.location,myself.location) <= 3)
        	   	{
        	   		add myself to: total_home_cell_near_shop_3;
        	   		
        	   	}
        	}
        }
        ask total_home_cells
        {
        	ask total_street_cells
        	{
        		if (distance_to(self.location,myself.location) <= 1)
        	   	{
        	   		add myself to: total_home_cell_near_street_1;
        	   		
        	   	}
        	}
        }
        ask total_shop_cells
        {
        	ask total_home_cells
        	{
        		if (distance_to(self.location,myself.location) <= 5)
        	   	{
        	   		add myself to: total_shop_cell_near_home_5;
        	   		
        	   	}
        	   	if (distance_to(self.location,myself.location) <= 1)
        	   	{
        	   		add myself to: total_shop_cell_near_home_1;
        	   		
        	   	}
        	}
        }
        
        ask total_shop_cells
        {
        	ask total_mainroad_cells
        	{
        		if (distance_to(self.location,myself.location) <= 3)
        	   	{
        	   		add myself to: total_shop_cell_near_mainroad_3;
        	   		
        	   	}
        	}
        }
        loop i over: total_home_cells
        {
        	if i!=nil
        		  	{
        		  		add string(((i).location).z) at: string(((i).location).x)+":"+string(((i).location).y) to:home_map;
        		  	}
        }
          loop i over: total_shop_cells
        {
        	if i!=nil
        		  	{
        		  		add string(((i).location).z) at: string(((i).location).x)+":"+string(((i).location).y) to:shop_map;
        		  	}
        }
        
      
  		//12 units = 1 home
  		total_homes <- int((length(total_home_cells)) / 12);
  
  		total_male <- int(total_homes * male_per_home);
  		total_female <- int(total_homes * female_per_home);
  		total_kid <- int(total_homes * kid_per_home);
  		total_visitor <- int(total_homes * visitor_per_home);
  
        create female number: total_female 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create male number: total_male 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create kid number: total_kid 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
            list<cell> home_cells <- list<cell>(agents_overlapping(living_place));
            next_to_street <- home_cells inter total_street_cells;
        }
        
        create visitor number: total_visitor 
        {
            living_place <- one_of(home_collection) ;
            location <- any_location_in (living_place);
            speed <- moving_speed ;
            end_point <- location;
            rule <- 'night_rule';
        }
	}
	
	int total_people;
	
	reflex color_update
	{
		mfc <- [];
		
		ask total_street_cells
		{
			total_people <- 0;
			
			ask male
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask female
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			ask kid
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}
			
			if(total_people >= 5)
			{
				add self to: mfc;
			}

			ask visitor
			{
				if (self overlaps myself)
				{
					total_people <- total_people + 1;
				}

			}

			if (total_people = 0)
			{
				color <- # lightskyblue;
			}

			if (total_people = 1)
			{
				color <- # green;
			}

			if (total_people = 2)
			{
				color <- # yellow;
			}

			if (total_people = 3)
			{
				color <- # orange;
			}

			if (total_people >= 4)
			{
				color <- # red;
			}

		}

	}
	int grey_rule_total_prople;
	int grey_rule_total_visitor;
//	reflex grey_rule when: count mod 1440 = 420 or count mod 1440 = 960 or count mod 1440 = 1200 or count mod 1440 = 840
//	{
//		list<cell> neighbor_24_home;
//		list<cell> neighbor_46_street;
//		list<cell> neighbor_81_shop;
//		if count mod 1440 = 420 or count mod 1440 = 960
//		{
//			loop i over: total_street_cell_near_home_2
//		{
//			neighbor_24_home<-( i neighbors_at 30);
//			neighbor_46_street<-( i neighbors_at 45);
//	
//			ask neighbor_24_home
//			{
//				grey_rule_total_prople <- 0;
//				grey_rule_total_visitor<-0;
//			
//			ask male
//			{
//				if (self overlaps myself)
//				{
//					grey_rule_total_prople <- grey_rule_total_prople + 1;
//				}
//
//			}
//
//			ask female
//			{
//				if (self overlaps myself)
//				{
//					grey_rule_total_prople <- grey_rule_total_prople + 1;
//				}
//
//			}
//
//			ask kid
//			{
//				if (self overlaps myself)
//				{
//					grey_rule_total_prople <- grey_rule_total_prople + 1;
//					
//				}
//
//			}
//			
//
//			ask visitor
//			{
//				if (self overlaps myself)
//				{
//					grey_rule_total_prople <- grey_rule_total_prople+ 1;
//					grey_rule_total_visitor<-grey_rule_total_visitor+1;
//					
//				}
//
//			}
//			
//			if (total_people)>2
//			{
//				ask  neighbor_46_street
//				{
//					if (self.color=#yellow)
//					{
//						if flip(0.9)
//						{
//							create pink_cube
//						{
//							location<-i.location;
//						}
//						}
//					
//					}
//				}  
//			}
//			if (grey_rule_total_visitor)>1
//			{
//				ask  neighbor_46_street
//				{
//					if (self.color=#green)
//					{
//						if (flip(0.6))
//						{
//							create pink_cube
//						{
//							location<-i.location;
//						}
//						}
//					}
//				}
//			}
//			
//		}
//		
//		}
//		}
//		if count mod 1440 = 840
//		{
//			loop i over: total_street_cell_near_home_5
//			{
//				neighbor_81_shop<-(i neighbors_at 60);
//				loop k over: neighbor_81_shop
//				{
//					ask total_shop_cells
//					{
//						if (distance_to(self.location,k.location) <= 5*15)
//							{
//								   grey_rule_total_prople <- 0;
//				              
//			
//			                       ask male
//			                    {
//				                    if (self overlaps k)
//				                 {
//					                grey_rule_total_prople <- grey_rule_total_prople + 1;
//				                  }
//
//			                     }
//
//			                     ask female
//			                      {
//				                     if (self overlaps k)
//				                  {
//					                   grey_rule_total_prople <- grey_rule_total_prople + 1;
//				                     }
//
//			                        }
//
//			                     ask kid
//			                        {
//				                   if (self overlaps k)
//				                {
//					           grey_rule_total_prople <- grey_rule_total_prople + 1;
//					
//				                  }
//
//			                       }
//			
//
//			                       ask visitor
//			                          {
//				                        if (self overlaps k)
//				                    {
//					             grey_rule_total_prople <- grey_rule_total_prople+ 1;
//				
//					
//				                     } 
//				                     }
//			                      if (grey_rule_total_prople)>10
//			                      {
//			                      	if flip(0.9)
//			                      	{
//			                      		create pink_cube
//			                      		{
//			                      			location<-i.location;
//			                      		}
//			                      	}
//			                      }
//							}
//				        }
//				
//				}
//			}
//		}	
//	
//	}
reflex save_result 
 {
        save ("current_day: "+current_day+" current_time: "+string(current_hour) + ':' + current_minute_string +" pink: "+ length((pink_cube)) + " cyan: " + length((cyan_cube))+" blue: "+length(blue_cube)+" yellow "+length(yellow_cube)) 
            to: "../result/data.txt" type: "text" rewrite:false; 
    
  }

reflex general_to_die 
{
	ask pink_cube_general
	{
		do die;
	}
	ask cyan_cube_general
	{
		do die;
	}
	ask blue_cube_general
	{
		do die;
	}
	ask yellow_cube_general
	{
		do die;
	}
	
}

reflex grey_rule when: count mod 1440 >= 420 and  count mod 1440 < 1080  
{
	list<cell> neighbor_2_home;
	

	list<cell> part_of_total_street_cell_near_home_2;
	list<cell> part_of_total_street_cell_near_home_5;
	bool peopel_number;
	bool visitor_numnber;
	bool green_frequency_of_path;
	bool red_frequency_of_path;
	bool orange_frequency_of_path;
	bool lunch_home_shop;
	bool lunch_people_number;
	
	if (count mod 1440 >= 420 and count mod 1440 < 840) or (count mod 1440 >= 960 and count mod 1440<1080)
		{  
			
			loop i from: 0 to: 100
			{
				add one_of(total_street_cell_near_home_2) to: part_of_total_street_cell_near_home_2;
			}
			
			loop i over:(part_of_total_street_cell_near_home_2)
			{
				neighbor_2_home<-(i neighbors_at 30);
				ask neighbor_2_home
				{
					if (self.color=#yellow)
					{
						peopel_number<-true;
					}
				}
				
				ask neighbor_2_home
				{
					if(self.color=#green)
					{
						green_frequency_of_path<-true;
					}
				}
				ask neighbor_2_home
				{
					if(self.color=#red)
					{
						red_frequency_of_path<-true;
					}
				}
				ask neighbor_2_home
				{
					ask visitor
					{
						 if (self overlaps myself)
				           {
					          grey_rule_total_prople <- grey_rule_total_prople+ 1;
				
					
				           } 
				          if(grey_rule_total_prople )>1
				           {
				          	visitor_numnber<-true;
				          }
				     }
				}
				ask neighbor_2_home
				{
					if(self.color=#orange )
					{
						orange_frequency_of_path<-true;
					}
				}
				
				if(peopel_number =true and green_frequency_of_path=true)
				{
					if(flip(0.9))
					{
						create pink_cube returns: each_one
					{
						location<-i.location;
						i.color<-#pink;
						
					}
					pink_cube_general <- pink_cube_general union each_one;
					
					}
				
				}
				if(peopel_number =true and red_frequency_of_path)
				{
					if (flip(0.6))
					{
						create pink_cube returns: each_one
					{
						location<-i.location;
						i.color<-#pink;
						
					}
					   pink_cube_general <- pink_cube_general union each_one;
					}
				
				}
				if( visitor_numnber=true and orange_frequency_of_path=true)
				{
					if (flip(0.6))
					{
						create cyan_cube  returns:each_one
					{
						location<-i.location;
						i.color<-#cyan;
						
					}
					cyan_cube_general <- cyan_cube_general union each_one;
					}
				}
				
				
				
			}
			
		}
			
			

  
  if (count mod 1440 >= 840 and count mod 1440 < 960)
  {
  	loop i from:0 to: 50
  
  	{
  		add one_of(total_street_cell_near_home_5) to:part_of_total_street_cell_near_home_5;
  	}


  	loop i over: part_of_total_street_cell_near_home_5
		{   
	           
		  list<cell> neighbor_3_home<-(i neighbors_at 45);
		  ask neighbor_3_home
		  {
			if(list(self) inter total_shop_cells)!=nil
			 {
				lunch_home_shop<-true;
			 }
			if (self.color=#red)
			{
				lunch_people_number<-true;
			}
	      }
	      if(lunch_home_shop=true and lunch_people_number=true )
			{
				if(flip(0.9))
				{
					create pink_cube returns: each_one
					  {
							location<-i.location;
					  }
						    pink_cube_general <- pink_cube_general union each_one;
				}
			}
	   }
	}
 }

reflex yellow_rule when: ( count mod 1440 >= 420 and  count mod 1440 < 1080 )
{   list<cell> part_home_cell_day;
	list<cell> part_home_cell_day_black;
	list<cell> part_home_neighbor_3;
	list<cell> part_home_neighbor_3_week;
	list<cell> part_home_neighbor_3_week_black;
	list<cell> part_home_cell_week;
	list<cell> part_home_cell_week_black;
	bool neighbor_color_pink_cyan;
	bool neighbor_color_orange;
	bool neighbor_color_pink_cyan_week;
	bool neighbor_color_red;
      
	bool near_blue;
	bool near_black;
	bool home_mainroad_neigbor_color_red;
	
	if ((count mod 1440 >= 420 and count mod 1440 < 840) or (count mod 1440 >= 960 and count mod 1440<1080)) and current_day mod 7!=0
	{   loop i from:0 to:50
		{
			add (one_of(total_home_cell_near_mainroad_30)) to:part_home_cell_day_black;
		}
		ask part_home_cell_day_black
		{
			if (flip(0.5))
			{
				create blue_cube returns:each_one
				{
					location<-myself.location;
					myself.color<-#blue;
				}
				 blue_cube_general <- blue_cube_general union each_one;
			}
		}
	}
	if (count mod 1440 >= 840 and count mod 1440 < 960 and current_day mod 7!=0 )
	{
		loop i from:0 to:50
		{
			add (one_of(total_home_cell_near_street_1)) to:part_home_cell_day;
		}
		loop i over: part_home_cell_day
		{
		 part_home_neighbor_3<-(i neighbors_at 45);
		 ask(part_home_neighbor_3)
		 {  
//		 	if((self.color=#pink or self.color=#cyan) )
//		 	{
//		 		neighbor_color_pink_cyan<-true;
//		 	}
		 	if((self.color=#orange) )
		 	{
		 		neighbor_color_orange<-true;
		 	}
		 }
		if (neighbor_color_orange=true )
		{
			if (flip(0.8))
			{
				create blue_cube returns:each_one
				{
					location<-i.location;
					i.color<-#blue;
					
				}
				blue_cube_general <- blue_cube_general union each_one;
			}
		}
		} 
	}
	
	
	if  ((count mod 1440 >= 420 and count mod 1440 < 840) or (count mod 1440 >= 960 and count mod 1440<1080)) and current_day mod 7=0
	{
	     
	     loop i from:0 to:50
		{
			
			add (one_of(total_home_cell_near_shop_3)) to:part_home_cell_week;
			
		}
		loop i from:0 to:50
		{
			
			add (one_of(total_home_cell_near_mainroad_30)) to:part_home_cell_week_black;
		}
		loop i over: part_home_cell_week
		{
			part_home_neighbor_3_week<-(i neighbors_at 75 );
			ask part_home_neighbor_3_week
			{
				
				if(self.color=#cyan or self.color=#pink)
				{
					neighbor_color_pink_cyan_week<-true;
				}
				if(self.color=#orange)
				{
					neighbor_color_red<-true;
				}				
			}
			if(neighbor_color_red=true and neighbor_color_pink_cyan_week=true )
				{
					if(flip(0.4))
					{
						create yellow_cube
					{   
						float height<-float(home_map[string(i.location.x)+":"+string(i.location.y)]);
						location<-{(i.location.x),(i.location.y),(height)};
						home_map[string(i.location.x)+":"+string(i.location.y)]<-string (height+15);

						
						
					}
					
					}
					
				}
			
		}	
			

			loop i over: part_home_cell_week_black
			{
				part_home_neighbor_3_week_black<-(i neighbors_at 150 );
				ask part_home_neighbor_3_week_black
				{
					if(self.color=#red)
				{
				    home_mainroad_neigbor_color_red<-true;
				}
				}
			   if (home_mainroad_neigbor_color_red=true)
			   {
			   	if(flip(0.3))
			   	{
			   		
						create yellow_cube
					{   
						float height<-float(home_map[string(i.location.x)+":"+string(i.location.y)]);
						location<-{(i.location.x),(i.location.y),(height)};
						home_map[string(i.location.x)+":"+string(i.location.y)]<-string (height+15);
						
					}
					
						create yellow_cube
					{   
						float height<-float(home_map[string(i.location.x)+":"+string(i.location.y)]);
						location<-{(i.location.x),(i.location.y),(height)};
						home_map[string(i.location.x)+":"+string(i.location.y)]<-string (height+15);
						
					}
			   	}
			   }
				
			
			}
		
		
		
	}
	
}
reflex blue_rule  
{
	    list<cell> part_blue_cells_5;
		list<cell> part_blue_cells_5_neighbor_5;
		list<cell> part_blue_cells_1;
		list<cell> part_blue_cells_black_3_neighbor_10;
		list<cell> part_blue_cells_balck_3;
		bool color_green;
		bool color_red;
	if (count mod 1440 >= 1200 and count mod 1440 <= 1440)  or (count mod 1440 >= 0 and count mod 1440 < 420) and current_day mod 7 !=0
	{
		
		loop i from:0 to:100
		{
			add one_of(total_shop_cell_near_home_5) to:part_blue_cells_5;
		}
		loop i over:part_blue_cells_5
		{
			part_blue_cells_5_neighbor_5<-(i neighbors_at 75);
			ask part_blue_cells_5_neighbor_5
			{
				if(self.color=#green)
				{
					color_green<-true;
				}
			}
			if(color_green=true)
			{
				if (flip(0.7))
				{
					create yellow_cube returns:each_one
				{
					location<-i.location;
				}
				yellow_cube_general<-yellow_cube_general union each_one;
				}
				
			}
		}
		
	}
	if (count mod 1440 >= 840 and count mod 1440 < 960 and current_day mod 7!=0)
	{
		loop i from: 0 to:50
		{
			add one_of(total_shop_cell_near_home_1) to:part_blue_cells_1;
			
		}
		ask (part_blue_cells_1)
		{
			if(flip(0.5))
			{
				create yellow_cube returns:each_one
				{
					location<-myself.location;
				}
				yellow_cube_general<-yellow_cube_general union each_one;
			}
		}
	}
	    
		if  ((count mod 1440 >= 420 and count mod 1440 < 840) or (count mod 1440 >= 960 and count mod 1440<1080)) and current_day mod 7=0
		{
			loop i from:0 to: 100
			{
				
				add one_of(total_shop_cell_near_mainroad_3) to:part_blue_cells_balck_3;
			}
			loop i over:part_blue_cells_balck_3
			{
				if( flip (0.05))
				{
					create blue_cube
					{   
						float height<-float(shop_map[string(i.location.x)+":"+string(i.location.y)]);
						location<-{(i.location.x),(i.location.y),(height)};
						shop_map[string(i.location.x)+":"+string(i.location.y)]<-string (height+15);
						
					}
				
				}
			}
			 loop i over:part_blue_cells_balck_3
			 {
			 	part_blue_cells_black_3_neighbor_10<-(i neighbors_at 150);
			 	
			 	
			 		ask part_blue_cells_black_3_neighbor_10
			 		{
			 			if(self.color=#orange)
			 			{
			 				color_red<-true;
			 			}
			 		}
			 	if (color_red=#orange)
			 	{
			 		if(flip(0.05))
			 		{
			 				create blue_cube
					{   
						float height<-float(shop_map[string(i.location.x)+":"+string(i.location.y)]);
						location<-{(i.location.x),(i.location.y),(height)};
						shop_map[string(i.location.x)+":"+string(i.location.y)]<-string (height+15);
						
					}
					
						create blue_cube
					{   
						float height<-float(shop_map[string(i.location.x)+":"+string(i.location.y)]);
						location<-{(i.location.x),(i.location.y),(height)};
						shop_map[string(i.location.x)+":"+string(i.location.y)]<-string (height+15);
						
					}
					
			 		}
			 	}
			 }
			 
		}
}
	
 
	reflex addcount
 	{
   		count <- count + 30;
   		current_hour <- int(count / 60) mod 24;
   		current_minute <- count mod 60;
   		
   		if(current_minute = 30)
   		{
   			current_minute_string <- '30';
   		}
   		else
   		{
   			current_minute_string <- '00';
   		}
   		
   		current_day <- int(count / 1440) + 1;
 	}
 	
 	
 	
 	
}


species bounds
{
	aspect geom
 	{
  		draw shape color: #black;
 	}
}

species shop 
{
 
    float height <- 1#m;
  
    aspect geom 
    {
        draw shape color: #blue depth: height;
    }
}

species home 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #yellow depth: height;
    }
}
species mainroad 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #black depth: height;
    }
}
species road 
{
    geometry display_shape <- shape + 2.0;
    aspect geom 
    {
        draw display_shape color: #black depth: 1.0;
    }
}
species street
{
 	float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #cyan depth: height;
    }
}


species Square 
{
    float height <- 20#m;
    
    aspect geom 
    {
        draw shape color: #lawngreen depth: height;
    }
}

species school 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #green depth: height;
    }
}
species blue_cube
{
	aspect geom 
    {
        draw cube(18) color: #blue;
    }
}
species pink_cube
{
	aspect geom 
    {
        draw cube(15) color: #pink;
    }
} 
species yellow_cube
{
	aspect geom
	{
		draw cube(15) color:#yellow;
	}
}
species cyan_cube
{
	aspect geom 
    {
        draw cube(15) color: #cyan;
    }
} 

grid cell cell_width: 15 cell_height: 15 neighbors: 8
{
	rgb color;
}

experiment shopandhouse type: gui 
{
   parameter "Shapefile for the roads:" var: bound category: "GIS" ;
   
   output 
   {
        display map_3D type: opengl ambient_light: 120 synchronized: true
        {
        	grid cell;
        	
        	species road aspect: geom refresh:true transparency: 0.8;
            species home aspect: geom refresh:true;   
            species shop aspect: geom refresh:true; 
            species Square aspect: geom refresh:true; 
            species school aspect: geom refresh:true; 
            species mainroad aspect: geom refresh:true;
            species pink_cube aspect: geom refresh:true; 
            species cyan_cube aspect: geom refresh:true; 
            species blue_cube aspect: geom refresh:true;
            species yellow_cube aspect: geom refresh:true;
            species male aspect: base ;
            species kid aspect: base ;                                                
            species visitor aspect: base ;
            species female aspect: base ;
            
            graphics 'current time'
			{
				draw string(current_hour) + ':' + current_minute_string at: { 800, 800 } color: # black font: font("Helvetica", 45 , #plain);
				draw 'Day' + string(current_day) at: { 800, 400 } color: # black font: font("Helvetica", 35 , #plain);
			}
        }
        
        display pink_chart
        {
        	chart "number of pink_cube " type: series x_label: "Time" x_serie_labels: string(current_hour) + ':' + current_minute_string y_label: 'Number of pink_cube'
        	{
        		data "pink_cube" value: length(pink_cube);
        	}

        }

        display cyan_chart
        {
        	chart "number of cyan_cube" type: series x_label: "Time" x_serie_labels: string(current_hour) + ':' + current_minute_string y_label: 'Number of cyan_cube'
        	{
        		data "cyan_cube" value: length(cyan_cube) color: # blue;
        	}

        }

        display my_chart
        {
        	chart "number of cyan_cube and number of pink_cube" type: series x_label: "Time" x_serie_labels: string(current_hour) + ':' + current_minute_string y_label: 'Number of cube'
        	{
        		data "pink_cibe" value: length(pink_cube);
        		data "cyan_cube" value: length(cyan_cube);
        	}

        }
    }
}
