model tutorial_gis_city_traffic

global 
{
 int count <- 0;
 int number <- 0;
 
 int total_homes;
 float male_per_home <- 1.0 parameter: 'male per home';
 float female_per_home <- 1.0 parameter: 'female per home';
 float kid_per_home <- 1.0 parameter: 'kid per home';
 float visitor_per_home <- 0.3 parameter: 'visitor per home';
 
 int total_male;
 int total_female;
 int total_kid;
 int total_visitor;
 
 
 reflex addcount
 {
  count <- count + 1;
 }
 
file blue_shops <- file('../includes/model/9.shp');
  file yellow_homes <- file('../includes/model/7.shp');
    file shape_file_roads <- file("../includes/model/14.shp");
 
    geometry shape <- envelope(shape_file_roads);

    init 
    {
    	create home from: yellow_homes with: [type::string(read ("NATURE"))]
    	{
    		
    	}
        create shop from: blue_shops 
        {
           
        }
      
        create home from: yellow_homes 
        {
      
        }
        
        create road from: shape_file_roads
        {
        
        }
     
  list<cell> total_home_cells <- list<cell>(agents_inside(home)) ;
  //12 units = 1 home
  total_homes <- int((length(total_home_cells)) / 12);
  
  total_male <- int(total_homes * male_per_home);
  total_female <- int(total_homes * female_per_home);
  total_kid <- int(total_homes * kid_per_home);
  total_visitor <- int(total_homes * visitor_per_home);
  
   list<home> residential_buildings <- home;
       create female number: total_female {
            location <- any_location_in (one_of (residential_buildings));
        }
        create male number: total_male {
            location <- any_location_in (one_of (residential_buildings));
        }
        create kid number: total_kid {
            location <- any_location_in (one_of (residential_buildings));
        }
        create visitor number: total_visitor {
            location <- any_location_in (one_of (residential_buildings));
        }
  
    }
}



species bounds
{
 aspect geom
 {
  draw shape color: #black;
 }
}

species shop 
{
 
    float height <- 1#m;
  
    aspect geom 
    {
        draw shape color: #blue depth: height;
    }
}

species home 
{
    float height <- 1#m;
    
    aspect geom 
    {
        draw shape color: #yellow depth: height;
    }
}

species road 
{
    geometry display_shape <- shape + 2.0;
    aspect geom 
    {
        draw display_shape color: #black depth: 3.0;
    }
}

species male {
    rgb color <- #black ;

    aspect base {
        draw circle(10#m) color: color;
    }
}
species female
{
  rgb color <- #green ;

    aspect base {
        draw circle(10#m) color: color;
    }
}

species kid
{
  rgb color <- #red ;

    aspect base {
        draw circle(10#m) color: color;
    }
}

species visitor
{
 rgb color <- #orange ;

    aspect base {
        draw circle(10#m) color: color;
    }
}

grid cell cell_width:15 cell_height:15 neighbors: 4
{
}

experiment shopandhouse type: gui 
{
   parameter "Shapefile for the roads:" var: shape_file_roads category: "GIS" ;
   
   output 
   {
        
        display map_3D type: opengl ambient_light: 120 
        {
            species road aspect: geom refresh:true;
            species home aspect: geom refresh:true;   
            species shop aspect: geom refresh:true; 
            grid cell lines: #black;
            species female aspect: base ;
            species male aspect: base ;
            species kid aspect: base ;                                                
            species visitor aspect: base ;
        }
    }
}